<section>
  <h3>Choose input values</h3>
  <form [formGroup]="inputValuesFormGroup" (ngSubmit)="onSubmit()">
    <div class="coordinates" formArrayName="x0">
      <mat-form-field *ngFor="let coordinate of coordinatesInput.controls; let i=index">
        <mat-label>
          x0[{{i}}]
        </mat-label>
        <input type="number" matInput [formControlName]="i"/>
      </mat-form-field>
    </div>
    <mat-form-field>
      <mat-label>
        &epsilon;1
      </mat-label>
      <input type="number" matInput formControlName="e1"/>
    </mat-form-field>
    <mat-form-field>
      <mat-label>
        &epsilon;2
      </mat-label>
      <input type="number" matInput formControlName="e2"/>
    </mat-form-field>
    <mat-form-field>
      <mat-label>
        M (max number of iterations)
      </mat-label>
      <input type="number" matInput formControlName="M"/>
    </mat-form-field>
    <button mat-raised-button color="primary" [disabled]="!inputValuesFormGroup.valid">
      Submit input values
    </button>
  </form>
</section>

<section>
  <h3>Solution</h3>
  <ng-container *ngIf="iterations$ | async; let iterations; else noSolvingYet">
    <ng-container *ngIf="iterations && iterations.length; else noSolvingYet">
      <table mat-table [dataSource]="iterations">
        <ng-container matColumnDef="numberOfIteration">
          <th mat-header-cell *matHeaderCellDef> № </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.numberOfIteration}} </td>
        </ng-container>

        <ng-container matColumnDef="gradient">
          <th mat-header-cell *matHeaderCellDef> ∇f </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.gradient | numberFormatting | coordinatesArray }} </td>
        </ng-container>

        <ng-container matColumnDef="t">
          <th mat-header-cell *matHeaderCellDef> t </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.t| numberFormatting}} </td>
        </ng-container>

        <ng-container matColumnDef="x">
          <th mat-header-cell *matHeaderCellDef> x[k] </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.x | numberFormatting | coordinatesArray}} </td>
        </ng-container>

        <ng-container matColumnDef="xNext">
          <th mat-header-cell *matHeaderCellDef> x[k + 1] </th>
          <td mat-cell *matCellDef="let iteration"> {{iteration.xNext | numberFormatting | coordinatesArray}} </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
      </table>
    </ng-container>
  </ng-container>
  <ng-template #noSolvingYet>
    No solution
  </ng-template>
</section>

<section>
  <h3>Result</h3>
  <ng-container *ngIf="result; else noResultYet">
    <p>Extremum point: {{result.extremumPoint | numberFormatting | coordinatesArray}}</p>
    <p>Function value: {{result.functionValue | numberFormatting}}</p>
  </ng-container>
  <ng-template #noResultYet>
    <p *ngIf="errorMessage; else calculating">
      {{errorMessage}}
    </p>
    <ng-template #calculating>
      No result yet
    </ng-template>
  </ng-template>
</section>
